<template>
  <div v-if="connected">
    <div
      v-if="
        serie.inSubscription &&
        !subscribed &&
        ((serie.isWebtoon && inline) || (!serie.isWebtoon && !inline))
      "
      class="serie-info-banner"
      :class="{ inline: inline }"
    >
      <div class="trunk info-ctn subscribe-cta">
        <p class="info-text">
          {{
            serie.isWebtoon
              ? $t('serie.subscribe_webtoon')
              : $t('serie.subscribe_serie')
          }}
        </p>

        <AppButton :theme="'secondary'" @click="redirectToSubscribe()">
          {{ $t('serie.button_benefit') }}
        </AppButton>
      </div>
    </div>
    <div
      v-else-if="!isSubscription && serie.serieBuyAll.price && !inline"
      class="serie-info-banner"
      :class="{ inline: inline }"
    >
      <div class="trunk info-ctn">
        <p class="info-text">
          {{ $t('serie.buyall', { name: serie.name }) }}
          <PriceFormatPlain
            class="price"
            :price="serie.serieBuyAll.price.toString()"
            :currency="serie.serieBuyAll.currency"
          />
          <del v-if="hasOldPrice">
            <PriceFormatPlain
              class="price"
              :price="serie.serieBuyAll.oldprice.toString()"
              :currency="serie.serieBuyAll.currency"
            />
          </del>
        </p>
        <template v-if="!serie.serieBuyAll.allInCart">
          <AppButton class="only-desktop" @click="addToCart()">
            {{ $t('catalog.add_basket') }}
          </AppButton>
          <AppButton class="only-mobile small-button" @click="addToCart()">
            <span class="icon icon-cart"></span>
          </AppButton>
        </template>
        <template v-else>
          <AppButton
            class="only-desktop"
            theme="white"
            @click="removeFromCart()"
          >
            {{ $t('catalog.added_basket') }}
          </AppButton>
          <AppButton
            class="only-mobile small-button mobile-cart-btn"
            theme="white"
            @click="removeFromCart()"
          >
            <img :src="require('~/assets/images/ic_cart_clicked.png')" />
          </AppButton>
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import AppButton from '~/components/ui/AppButton'
import PriceFormatPlain from '~/components/ui/PriceFormatPlain'

export default {
  components: {
    AppButton,
    PriceFormatPlain
  },
  props: {
    serie: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: false,
      default: false
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    },
    subscribed: {
      type: Boolean,
      required: false,
      default: false
    },
    inline: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  computed: {
    hasOldPrice() {
      return (
        this.serie.serieBuyAll.price &&
        this.serie.serieBuyAll.price !== 'N/A' &&
        this.serie.serieBuyAll.oldprice &&
        this.serie.serieBuyAll.oldprice !== 'N/A' &&
        this.serie.serieBuyAll.price !== this.serie.serieBuyAll.oldprice
      )
    }
  },
  methods: {
    async addToCart() {
      const data = await this.$api.addSerieToCart(this.serie.id)
      if (data) {
        this.$store.dispatch('updateCartItemCount')

        this.$utils.gtmEvent({
          event: 'addToCart',
          EventCategory: 'ecommerce',
          EventAction: 'add to cart',
          ecommerce: {
            currencyCode: this.$utils
              .getCurrencyBySymbol(this.serie.serieBuyAll.currency)
              .toUpperCase(),
            add: {
              products: [
                {
                  name: this.serie.name,
                  id: this.serie.id,
                  price: this.serie.serieBuyAll.price,
                  brand: this.serie.shelf.name,
                  category: 'Series',
                  variant: this.serie.publishers.length
                    ? this.serie.publishers.map((v) => v.name).join(', ')
                    : '',
                  dimension1: this.serie.target.name,
                  dimension2: '',
                  quantity: 1
                }
              ]
            }
          }
        })

        this.$root.$emit('refreshSerie', this.serie.id)
      }
    },
    async removeFromCart() {
      const data = await this.$api.removeSerieFromCart(this.serie.id)
      if (data) {
        this.$store.dispatch('updateCartItemCount')

        this.$utils.gtmEvent({
          event: 'removeFromCart',
          EventCategory: 'ecommerce',
          EventAction: 'remove from cart',
          ecommerce: {
            currencyCode: this.$utils
              .getCurrencyBySymbol(this.serie.serieBuyAll.currency)
              .toUpperCase(),
            remove: {
              products: [
                {
                  name: this.serie.name,
                  id: this.serie.id,
                  price: this.serie.serieBuyAll.price,
                  brand: this.serie.shelf.name,
                  category: 'Series',
                  variant: this.serie.publishers.length
                    ? this.serie.publishers.map((v) => v.name).join(', ')
                    : '',
                  dimension1: this.serie.target.name,
                  dimension2: '',
                  quantity: 1
                }
              ]
            }
          }
        })

        this.$root.$emit('refreshSerie', this.serie.id)
      }
    },
    redirectToSubscribe() {
      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'Clic_Bouton',
        EventAction: 'Abonnement',
        EventLabel: 'Activer-gratuitement'
      })

      // to be improved when subscription will be in VueJs Project
      const url = this.$utils.getSubscribeUrlForLang(this.$i18n.locale)

      let subscriptionId
      // business rule:
      // don't let a user choose, put izneo Webtoon in cart for webtoons
      // and put izneo Pass for regular albums.
      // we need to check if current webtoon is included in izneo Webtoon
      if (!this.serie.isWebtoon) {
        // izneo Pass or Premium
        subscriptionId = this.$i18n.locale === 'fr' ? 1 : 25
      } else {
        // webtoon unlimited
        subscriptionId =
          this.serie.classicSubscriptions.map((v) => v.id).indexOf('28') >= 0
            ? 28
            : 1
      }
      window.location.href = `${this.$config.izneoUrl}/${this.$i18n.locale}/${url}/${subscriptionId}`
    }
  }
}
</script>

<style lang="scss" scoped>
.serie-info-banner {
  padding: 1rem 0;
  background-color: #fff3db;

  &.inline {
    padding: 1.5rem;
    background-color: inherit;
    border-bottom: solid 1px #d8d8d8;

    .info-ctn {
      justify-content: space-evenly;

      @media (max-width: 768px) {
        flex-direction: column;

        .button {
          width: unset;
        }
      }
    }

    .trunk {
      padding: 1rem;
      background-color: #fff3db;
      text-align: center;
    }
  }
}

.info-ctn {
  display: flex;
  justify-content: space-between;
  align-items: center;

  @media (max-width: 768px) {
    .button {
      flex-shrink: 0;
    }
  }

  &.subscribe-cta {
    @media (max-width: 768px) {
      flex-direction: column;
      .button {
        width: unset;
      }
    }
  }
}

.info-text {
  font-size: 32px;
  font-weight: bold;
  font-stretch: condensed;
  font-family: DINCond-Bold;

  del {
    color: grey;
  }

  @media (max-width: 768px) {
    padding-right: 1rem;
    line-height: 2rem;
    font-size: 25px;
  }
}
</style>
